# <img src="./Resources/DeepMuon.png" width =900px>

## Introduction

DeepMuon is a easy-using deep learning platform built for dark matter searching experiments, we are eager to provide advanced model training frame and excellent project management assistance.

Here we list out the available features of DeepMuon:

- DeepMuon support **Single GPU** training and **Distributed Data Parallel** training
- Model Inference and analysis
- Customize models
- Customize datasets
- Customize loss functions
- Easy to train/inference
- Tidy file system
- Simple and direct tutorials

## Installation

```bash
git clone https://github.com/Airscker/DeepMuon.git
cd DeepMuon
pip install -v -e ./ --user
```

## Tutorials

- [Regulations](./Tutorial/1.Regulations.md)
- [Customize Dataset](./Tutorial/2.Customize Dataset.md)
- [Customize Model](./Tutorial/3.Customize Model.md)
- [Configuration](./Tutorial/4.Configuration.md)
- [Training and Inference](./Tutorial/5.Training and Inference.md)

## CopyRight

> GNU AFFERO GENERAL PUBLIC LICENSE
> 		Project: DeepMuon
> 		Dark Matter Searching Deep Learning Platform
> 		Author: Airscker/Yufeng Wang
> 		Contributors: Yufeng Wang, Yu Zhang
> 		University of Science of Technology and Science of China
> 		Internal supported sensor's dataset: Pandax-4T, Hailing
> 		If you want to publish thesis using DeepMuon, please add bibliography:
>
> > To be published
>
> Copyright (C) 2022 by Airscker, All Rights Reserved.
